package akronyymid;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.regex.*;

public class Akronyym {
	static ArrayList<String> akronyymid = new ArrayList<String>(); 
	static String akr_regex= "[A-Z0-9][A-Z]{1,9}"; // regulaaravaldis, mis hakkab akronme tekstist tuvastama
	static ArrayList<String> akronyymid_lahendid = new ArrayList<String>();
	static String kaust = "C:/artiklid"; //kaust, kus hakatakse artikleid otsima

public static void main (String[] args) throws IOException {
	String tekst = "";
	File directory = new File(kaust);
	File files[] = directory.listFiles();
	for (File f : files) {
		tekst = read(f.toString());	
		Pattern p = Pattern.compile(akr_regex, Pattern.MULTILINE);
		Matcher m = p.matcher(tekst);
		while ( m.find() )
		{
			for ( int i = 0; i <= m.groupCount(); i++ )
			{
				// ritab iga leitud akronmile lahendit leida:
				addToAcronyms(m.group(i), tekst);
			}
		}
    }
	System.out.println("Leitud akronmid ("+ akronyymid.size() +"): "+ akronyymid.toString());
	System.out.println("Lahendatud akronmid ("+ akronyymid_lahendid.size() +"): "+ akronyymid_lahendid.toString());
}



static String read(String fileName) throws IOException {
    System.out.println("Loen failist: "+ fileName);
    StringBuilder text = new StringBuilder();
    String NL = System.getProperty("line.separator");
    Scanner scanner = new Scanner(new FileInputStream(fileName));
    try {
      while (scanner.hasNextLine()){
        text.append(scanner.nextLine() + NL);
      }
    }
    finally{
      scanner.close();
    }
	return text.toString();
  }

// Koostab antud akronmide lahendite regulaaravaldise ja ritab neid tekstist leida
// Lahendite regulaaravaldised muutuvad igal etapil ha tpsemast ahnemaks (greedy).
// Kui mingil etapil leitakse vaste, siis edasi ei otsita (leitakse parim)
// A - akronm, tekst - 
 static void addToAcronyms(String A, String tekst) {
	     if (!akronyymid.contains(A)) akronyymid.add(A); 
	     
	 	 // Kui akronm lisatakse, siis tehakse sellest regulaaravaldis - akronym_expanded	 	 
	 	 String acronym_expanded = makeAcronymRegex(A, "");
	 	 // 1. tpjuht: akronuumi vaste on akronmi ees vi jrel
		 String regex = A +" [(]?[ ]?"+ acronym_expanded +"[ ]?[)]?";	
		 if (matchPattern(regex, tekst, A)) return; 	
		 regex = acronym_expanded + " [(]?[ ]?"+ A +"[ ]?[)]?";
		 if (matchPattern(regex, tekst, A)) return;

		 // 2. tpjuht: leiab tekstist suvalisel kohal leiduva Xxx Yyy Zzzz:
		 acronym_expanded = makeAcronymRegex(A, "");
		 regex = " "+ acronym_expanded +" ";		
		 if (matchPattern(regex, tekst, A)) return;
	 
		 // 3. tpjuht: kui akronmi lahendi vahel asuvad artiklid, eessnad vi sidesnad
		 acronym_expanded = makeAcronymRegex(A, "[a-z ]{0,5}");
		 regex = A +" [(]?"+ acronym_expanded ;		
		 if (matchPattern(regex, tekst, A)) return;
		 regex = acronym_expanded +" [(]?[ ]?"+ A;
		 if (matchPattern(regex, tekst, A)) return;
		 
		 // 4. tpjuht: kui akronmi ees vi jrel asub vga pikk liitsna,
		 // mis algab akronmi esimese (suure vi vikese) esithega.
		 acronym_expanded = " ["+ A.substring(0, 1) +""+ A.substring(0, 1).toLowerCase() +"][a-z]{10,"+ A.length()*10 +"} ";
		 regex = acronym_expanded  + "[(][ ]?"+ A;		
		 if (matchPattern(regex, tekst, A)) return;
		 regex = " [(]?[ ]?"+ A +"[ ]?[)] ?"+ acronym_expanded;
		 if (matchPattern(regex, tekst, A)) return;
		 

		 // Ohtlikud ehk vigu tegevad reeglid:
		 // 5. tpjuht: ritab leida vasteid, mis on kirjutatud vikeste thtedega
		 if (A.length()> 2) {
			 acronym_expanded = makeAcronymRegex(A.toLowerCase(), "");
			 regex = " "+ acronym_expanded +" ";
			 if (matchPattern(regex, tekst, A.toLowerCase())) return;	
		 }

		 
		 // 6. tpjuht: Kui eelnevatest tpjuhtudest pole lahendit leitud
		 Pattern p = Pattern.compile(A);
		 for (int i=0;i<akronyymid_lahendid.size();i++) {
			 Matcher m = p.matcher(akronyymid_lahendid.get(i).toString());
		     if (m.find()) return; 
		 }
		 
		 // Kombinatsioonid n-1/n kaupa siis kui akronm on pikem kui 3:
		 if (A.length()>3) {
		 String[] elements = A.split("");
		 CombinationGenerator x = new CombinationGenerator (elements.length, elements.length-1);
		 int[] indices;
		 StringBuffer combination;
		 while (x.hasMore ()) {
		   combination = new StringBuffer ();
		   indices = x.getNext ();
		   for (int i = 0; i < indices.length; i++) {
		     combination.append (elements[indices[i]]);
		   }
			 acronym_expanded = makeAcronymRegex(combination.toString(), "");
			 regex = acronym_expanded +" ";		
			 matchPattern(regex, tekst, A);
		 }
		 }
}		 

 
 // ritab antud tekstist antud akronmi leida. Tagastab tevrtuse kas leidus.
 static boolean matchPattern(String matched, String tekst, String A) {
	 Pattern p = Pattern.compile(matched);
	 Matcher m = p.matcher(tekst);
		while ( m.find() )
		{
			final int gc = m.groupCount();
			for ( int i = 0; i <= gc; i++ )
			{ 
				String puhas_vaste = m.group(i).replaceAll("[^ A-z0-9\\-]" , "");
				if (puhas_vaste.contains(A)) puhas_vaste = puhas_vaste.replaceAll(A, "");

				 if (!akronyymid_lahendid.contains(A +"="+ puhas_vaste)) 
				 {
					 System.out.println(puhas_vaste);
					 akronyymid_lahendid.add(A +"="+ puhas_vaste);
					 return true;
				 }
			}
		}
		return false;
 }
 
 // Loob antud akronmi (A) tema vimaliku laiendi regulaaravaldise
 // arvestades akronmi laiendi snade vahel vimalikke eessnu, artikleid jm (vahe)
 static String makeAcronymRegex (String A, String vahe) {
	 String[] esit2hed = A.split("");
	 String acronym_expanded = "";
	 for (int i=0;i<esit2hed.length;i++) {
		 if (i==0) {
			 acronym_expanded += vahe + esit2hed[i];
		 	}
		 else if (i+1 == esit2hed.length) // 
			 {
			 acronym_expanded += esit2hed[i] +"[^ -]*";
			 }
		 else if (i != 0){
			 acronym_expanded += esit2hed[i] +"[^ -]*[ -]"+ vahe + "";
		 	}
	 }
	 return acronym_expanded;
 } 
}
